
package de.ivu.elect.business.kandidatenportal.boundary;

import javax.enterprise.context.RequestScoped;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;

import de.ivu.elect.business.kandidatenportal.entity.WvpBenutzer;

@RequestScoped
@Named(WvpBenutzerConversationSelect.COMPONENT_NAME)
public class WvpBenutzerConversationSelect implements java.io.Serializable {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "wvpBenutzerConversationSelect";

  @Inject
  protected transient WvpBenutzerExtendedDAO entityDAO;

  @Inject
  @ConversationGroup(WvpBenutzerConversationStore.class)
  protected transient WvpBenutzerConversationStore conversationStore;

  public WvpBenutzerConversationSelect() {
    super();
  }

  public boolean isSelected() {
    return getEntityPK() != null;
  }

  public WvpBenutzer getEntity() {
    return getEntityInternal();
  }

  private WvpBenutzer getEntityInternal() {
    if (getEntityPK() == null) {
      return null;
    }

    return attach(getEntityPK());
  }

  public void setEntity(WvpBenutzer entity) {
    setEntityAttached(attach(entity));
  }

  public void setEntity( de.ivu.elect.business.person.entity.PersonendatenPK  pk) {
    setEntityAttached(attach(pk));
  }

  protected void setEntityAttached(WvpBenutzer entity) {
    if(entity == null) {
      setEntityPK(null);
    } else {
      setEntityPK(entity.getPk());
    }
  }

  public
    de.ivu.elect.business.person.entity.PersonendatenPK
   getEntityPK() {
    return conversationStore.getEntityPK();
  }

  public void setEntityPK(
    de.ivu.elect.business.person.entity.PersonendatenPK
   entityPK) {
    conversationStore.setEntityPK(entityPK);
  }

  protected WvpBenutzer attach(WvpBenutzer entity) {
    if (entity == null){
      return null;
    }

    return attach(entity.getPk());
  }

  protected WvpBenutzer attach( de.ivu.elect.business.person.entity.PersonendatenPK  pk) {
    if (pk == null) {
      return null;
    }

    return entityDAO.findByPrimaryKey(pk);
  }

  public void clearEntity() {
    setEntityPK(null);

    conversationStore.close();
  }
}
